//卐 ᴥ ۩ Ѿ Ѯ

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll inf = 1e15;
constexpr ll mod = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    ll n, m, k;
    cin >> n >> m >> k;
    vector<vector<ll>> g(n);
    for (int i = 0; i < m; ++i) {
        ll x, y;
        cin >> x >> y;
        x--; y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    vector<pair<ll,ll>> s(k);
    for (int i = 0; i < k; ++i) {
        cin >> s[i].second >> s[i].first;
    }
    ranges::sort(s, greater<pair<ll,ll>>());
    vector<ll> dist(n, -1);
    for (int i = 0; i < k; ++i) {
        ll p = s[i].second;
        const ll h = s[i].first;
        p--;
        if (dist[p] < h) {
            queue<ll> q;
            q.push(p);
            dist[p] = h;
            while (!q.empty()) {
                const ll v = q.front();
                q.pop();
                for (const ll to : g[v]) {
                    if (dist[v] - 1 > dist[to]) {
                        dist[to] = dist[v] - 1;
                        q.push(to);
                    }
                }
            }
        }
    }
    vector<ll> ans;
    for (int i = 0; i < n; ++i) {
        if (dist[i] >= 0) {
            ans.push_back(i+1);
        }
    }
    cout << ans.size() << '\n';
    for (const ll x : ans) {
        cout << x <<  " ";
    }
    return 0;
}
