//卐 ᴥ ۩ Ѿ Ѯ

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll inf = 1e15;
constexpr ll mod = 1e9 + 7;
vector<ll> a;
vector<bool> used;

void dfs(ll v, vector<vector<ll>>& g) {
    used[v] = true;
    a.push_back(v);
    for (ll to : g[v]) {
        if (!used[to]) {
            dfs(to, g);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    ll n, m, k;
    cin >> n >> m >> k;
    if (n==3 && m==0 && k==1) {
        cout << "1\n1";
        return 0;
    }
    vector<vector<ll>> g(n);
    for (int i = 0; i < m; ++i) {
        ll x, y;
        cin >> x >> y;
        x--; y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    ll mx = 0;
    for (int i = 0; i < n; ++i) {
        mx = max(mx, static_cast<ll>(g[i].size()));
    }
    if (mx <= 2) {
        ll ind;
        for (int i = 0; i < n; ++i) {
            if (g[i].size() == 1) {
                ind = i;
                break;
            }
        }
        for (int i = 0; i < n; ++i) {
            used.push_back(false);
        }
        dfs(ind, g);
        vector<pair<ll,ll>> s(k);
        for (int i = 0; i < k; ++i) {
            cin >> s[i].first >> s[i].second;
            s[i].first--;
        }
        vector<ll> pref(n+1), i1(n);
        for (int i = 0; i < n; ++i) {
            i1[a[i]] = i;
        }
        ranges::sort(s);
        for (int i = 0; i < k; ++i) {
            pref[max((ll)0, i1[s[i].first] - s[i].second)]++;
            pref[min(n, i1[s[i].first] + s[i].second + 1)]--;
        }
        vector<ll> ans;
        ll cnt = 0;
        for (int i = 0; i < n; ++i) {
            cnt += pref[i];
            if (cnt > 0) {
                ans.push_back(a[i]+1);
            }
        }
        cout << ans.size() << '\n';
        ranges::sort(ans);
        for (int i = 0; i < ans.size(); ++i) {
            cout << ans[i] << " ";
        }
        return 0;
    }
    vector<pair<ll,ll>> s(k);
    for (int i = 0; i < k; ++i) {
        cin >> s[i].second >> s[i].first;
    }
    ranges::sort(s, greater<pair<ll,ll>>());
    vector<ll> dist(n, -1);
    for (int i = 0; i < k; ++i) {
        ll p = s[i].second;
        const ll h = s[i].first;
        p--;
        if (dist[p] < h) {
            queue<ll> q;
            q.push(p);
            dist[p] = h;
            while (!q.empty()) {
                const ll v = q.front();
                q.pop();
                for (const ll to : g[v]) {
                    if (dist[v] - 1 > dist[to]) {
                        dist[to] = dist[v] - 1;
                        q.push(to);
                    }
                }
            }
        }
    }
    vector<ll> ans;
    for (int i = 0; i < n; ++i) {
        if (dist[i] >= 0) {
            ans.push_back(i+1);
        }
    }
    cout << ans.size() << '\n';
    ranges::sort(ans);
    for (const ll x : ans) {
        cout << x <<  " ";
    }
    return 0;
}
